#!/usr/bin/perl

$gBaseURL = ".";
$gIconURL = "./images";
$gBaseDIR = ".";
$gCGI_URL = "./wj_poetry.cgi"; 

$gMakeBoard = "Y"; 	 
$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;
sub parseArgument {
    local($buffer,$data,$name,$value);
    local(@datum);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    }

    @datum = split(/&/,$buffer);
    foreach $data (@datum) {
        ($name,$value) = split(/=/,$data);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

        $FORM{$name} = $value;
    }
    if($FORM{'id'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'id'}";
        $gPgTitle = "<img src=$gIconURL/$FORM{'id'}.gif>";
        $gNumFile = "$FORM{'id'}.num";
        $gCfgFile = "$FORM{'id'}.cfg";
        $gPwdFile = "$FORM{'id'}.pwd";
        $gIdxFile = "$FORM{'id'}.idx";
    }
    else {
		&HTMLHeader;
		print "<form name=id>\n";
		print "<table border cellpadding=3 cellspacing=0 width=300 bgcolor=#f3f3f3 bordercolordark=#ffffff bordercolorlight=#c0c0c0>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center><font style=\"font-size:9pt\"> study cgi </font></td></tr>\n";
		print "<tr><td height=40 align=center><font style=\"font-size:9pt\">  DB  </font><input type=text name=id size=15 class=ad value=$DBname></td></tr>\n";
		print "<tr><td bgcolor=#e3e3e3 align=center>\n";
		print "<input type=submit value=\" DB  \" style=\"height:18px;font-size:9pt;background-color:#f3f3f3;border:1 solid #787878;cursor: hand\" OnClick=\"url_go('$gCGI_URL?id=$DBname')\">\n";
		print "</table></td></tr></table>\n";
		print "</form>\n";
		&HTMLFooter;
    }
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        if($gMakeBoard eq "Y") {
            &selectAction;
        }
        else {
            &HTMLHeader;
				print "<font style=\"font-size:9pt\">ڿ   Ǿ ϴ!</font>\n";
            &HTMLFooter;
        }
    }
}

sub selectAction {
    &getEnvVar;
    &getNumber;

    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;
   
    unless($FORM{'action'}) {
        $FORM{'action'} = "read";
    }
    if($FORM{'action'} eq "read") {	
        &readData;
    } 
    elsif($FORM{'action'} eq "input_form") {
        &checkAdminPassword;
        &showInputForm;
    }
    elsif($FORM{'action'} eq "write") {
        &writeData;
    } 
    elsif($FORM{'action'} eq "users_login") {
        &showUsersLogin;
    }
    elsif($FORM{'action'} eq "delete") {
        &checkUserPassword;
        &deleteData;
    } 
    elsif($FORM{'action'} eq "update_form") {
        &checkUserPassword;
        &showUpdateForm;
    } 
    elsif($FORM{'action'} eq "update") {
        &updateData;
    } 
    elsif($FORM{'action'} eq "admin_login") {
        &showAdminLogin;
    }
    elsif($FORM{'action'} eq "config_form") {
        &checkAdminPassword;
        &showConfigForm;
    }
    elsif($FORM{'action'} eq "config") {
        &updateEnvVar;
    }
    elsif($FORM{'action'} eq "follow") {
        &HTMLHeader;
        &followData;
        &DirectList;
        &HTMLFooter;
    }
    elsif($FORM{'action'} eq "search") {
        &searchData;
    }
    else {
        exit;
    }
}

sub getNumber {
    local($data,$size);
    local(@datum,@value);
   
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/messages",0777);
        
        open(HANDLE,">$gBaseDIR/$gIdxFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImage = $datum[2];
        $gBoardTitle = $datum[3];
        $gBoardImage = $datum[4];
        $gTableCell = $datum[5];
        $gBaseText = $datum[6];
		$gLink = $datum[7];
        $gLinkVisited = $datum[8];
        $gLinkActive = $datum[9];
        $gLinkHover = $datum[10];
        $gTableWidth = $datum[11];
        $gRecPerPage = $datum[12];
		$gListHover = $datum[13];
		$gTextSize = $datum[14];
		$gTextFamily = $datum[15];
        $gListNumber = $datum[16];
        $gShowSearch = $datum[17];
        $gShowDate = $datum[18];

        chop($gHomeImageURL);
    }
    else {
 
        $gBackColor = "#ffffff";
        $gBackImage = "";
        $gBoardTitle = "";
        $gBoardImage = "";
        $gTableCell = "#ffffff";
        $gBaseText = "#787878";
        $gLink = "#787878";
        $gLinkVisited = "#787878";
        $gLinkActive = "#787878";
        $gLinkHover = "#c0c0c0";
        $gTableWidth = "75%"; 
        $gRecPerPage = "15";
		$gListHover = "#f3f3f3";
		$gTextSize = "10pt";
		$gTextFamily = ",Tahoma";
        $gListNumber = "5";
        $gShowSearch = "YES";
        $gShowDate = "YES";

        &putEnvVar;
    }
}
 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "^^|$gBackColor|$gBackImage|$gBoardTitle|$gBoardImage|$gTableCell|$gBaseText|$gLink|$gLinkVisited|$gLinkActive|$gLinkHover|$gTableWidth|$gRecPerPage|$gListHover|$gTextSize|$gTextFamily|$gListNumber|$gShowSearch|$gShowDate|\n";
    close(HANDLE);
}

sub readData {
    &HTMLHeader;
    &PageHeader;
    &readIndexFile;
    &DirectList;
    &showSearchForm if($gShowSearch eq "YES");
    &PageFooter;
    &HTMLFooter;
}

sub readIndexFile {
    local($i,$j,$old_date,$new_date,$actual_number,$short_subject,$short_date);
    local(@datum,@value);
    
    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;
        if($actual_number > 0) {
            if($i%2) {
			    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0>\n";
			    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
            }
            else {
			    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=0>\n";
			    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
            }

            print "<tr align=center bgcolor=$gTableCell onMouseOver=this.style.backgroundColor='$gListHover' onMouseOut=this.style.backgroundColor='$gBackColor'>\n"; 
            $short_subject = substr($value[2],0,60);
            print "<td height=22 align=left>";
            for($j=1;$j<=$value[0];$j++) {
                 print " ";
            }
            $old_date = substr($value[5],0,10);
            &getDate;
            $new_date = substr($date,0,10);
            if($old_date eq $new_date) {
                if($value[0] == 0) {
                    print "&nbsp;<img src=$gIconURL/head.gif border=0> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a>&nbsp;&nbsp;&nbsp;&nbsp;<img src=$gIconURL/new.gif border=0></td>";
                }
            }
            else {
                if($value[0] == 0) {
                    print "&nbsp;<img src=$gIconURL/head.gif border=0> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$value[0]&p=$gCurPage&n=$i&l=$value[1]>$short_subject</a></td>";
                }
            }
            $short_date=substr($value[5],0,10);
	        if ($gShowDate eq "YES"){
                print "<td height=22 align=right>$short_date&nbsp;</td>";
	        }
        }
    }
    print "</tr>\n";
    print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
	print "</table>\n";
    unless($gNoOfData) {
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=1>\n";
        print "<tr bgcolor=$gTableCell align=center><td>ϵ  ϴ\n";
        print "</table>\n";
    }
}

sub DirectList  {
    print "<table border=0 cellpadding=2 cellspacing=0 width=$gTableWidth><tr><td><font size=1 face=Tahoma><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>list</a></font>";
    print "<td align=right><font size=1 face=Tahoma>\n";
    $term = $gListNumber;$f = 1;$l = $term;while ($f <= $gTotPage) {
        if (($f <= $gCurPage) && ($gCurPage <= $l)){
            $prevp = $f - 1;
            if ($prevp > 0) {
                print "[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$prevp>prev</a>]..";
            }
            else {
                print "";
            }
            if ($l <= $gTotPage) {
                for ($page = $f; $page <= $l; $page++) {
                    if ($page == $gCurPage) {
                        print "[<b>$page</b>]";
                    }
                    else {
                        print "[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page>$page</a>]";
                    }
                }
            }
            else {
                for ($page = $f; $page <= $gTotPage; $page++) {
                    if ($page == $gCurPage) {
                        print "[<b>$page</b>]";
                    }
                    else {
                        print "[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$page>$page</a>]";
                    }
                }
            }
            $nextp = $l + 1;
            if ($nextp <= $gTotPage) {
                print "..[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$nextp>next</a>]";
            }
            else {
                print "";
            }    
        }
        $f = $f + $term;
        $l = $l + $term;
    }
    print "</font></td></tr></table>\n";
}

sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "<!-------------------------------------------------------->\n";
    print "<!--                                                    -->\n";
    print "<!--    ƾ: ̼                                -->\n";
    print "<!--    ڿ: zeusso\@nownuri.net                    -->\n";
    print "<!--    Ȩ: http://soback.kornet21.net/~zeusso    -->\n";
    print "<!--                                                    -->\n";
    print "<!--    ƾ:                                 -->\n";
    print "<!--    ڿ: thief\@khim.pe.kr                      -->\n";
    print "<!--    Ȩ: http://www.khim.pe.kr/                -->\n";
    print "<!--                                                    -->\n";
    print "<!-------------------------------------------------------->\n";
    print "<html>\n";
    print "<head>\n";
    print "    <title> wj_poetry.cgi </title>\n";
    print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-KR\">\n";
    print "<style type='text/css'>\n";
    print "<!--\n";
    print "    a:link    { color:$gLink;text-decoration:none }\n" ;
    print "    a:visited { color:$gLinkVisited;text-decoration:none }\n" ;
    print "    a:active  { color:$gLinkActive;text-decoration:none }\n" ;
    print "    a:hover   { color:$gLinkHover;text-decoration:none }\n";
    print "    body      { background:$gBackColor; background-attachment: fixed; background-image: url($gBackImage); background-repeat: no-repeat; background-position: right bottom }\n";
	print "    body,td   { color:$gBaseText;font-size:$gTextSize;font-family:$gTextFamily }\n";
    print "    select,input,form,textarea,option { color:$gBaseText;font-size:$gTextSize }\n";
    print "    body {\n";
    print "        scrollbar-face-color:#ffffff;\n";
    print "        scrollbar-shadow-color:#787878;\n"; 
    print "        scrollbar-highlight-color:#f3f3f3;\n"; 
    print "        scrollbar-3dlight-color:#ffffff;\n"; 
    print "        scrollbar-darkshadow-color:#ffffff;\n"; 
    print "        scrollbar-track-color:#ffffff;\n";
    print "        scrollbar-arrow-color:#787878\n";
    print "}\n";
	print "-->\n";
    print "</style>\n";
    print "<script language=javascript>\n";
    print "    function clearField(field){\n";
    print "        if (field.value == field.defaultValue) {\n";
    print "            field.value = '';\n";
    print "     }\n";
    print "}\n";
    print "    function checkField(field){ \n";
    print "        if (field.value == '') {\n";
    print "            field.value = field.defaultValue;\n";
    print "     }\n";
    print "}\n";
    print "</script>\n";
    print "</head>\n";

    if($gDelayTime == 0) {
        print "<body topmargin=20>\n";
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>\n";
        print "<body topmargin=20>\n";
    }
    print "<center>\n";    
    if($gBoardImage) {
        print "<img src=$gBoardImage>\n";
    }
    else {
        print "<table border=0 cellspacing=0 cellpadding=0><tr align=center><td>$gBoardTitle</td></tr></table>\n";
    }
    print "<br>\n";
}

sub HTMLFooter {
    print "</center>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

sub PageHeader {
    print "<table width=$gTableWidth border=0 cellspacing=1 cellpadding=2>\n";
    print "<tr>\n";
    print "<td><font size=1 face=Tahoma>total <b>$gNoOfData</b> articles <b>$gCurPage</b>/<b>$gTotPage</b></font></td>\n";
    print "<td align=right><font size=1 face=Tahoma><a href=$gCGI_URL?id=$FORM{'id'}&action=admin_login&p=$gCurPage&c=config_form>login</a></font></td>\n";
    print "</tr></table>\n";
}

sub PageFooter {
	### Ʒ  ΰ ϰų  ! ###
    print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=2><tr><td align=center><font size=1 face=Tahoma><a href=http://soback.kornet21.net/~zeusso target=_blank title=\" ϴ Ȩ \">wonie</a> ::: <a href=http://www.khim.pe.kr/ target=_blank title=\"  Ȩ \">Khim</a></font></td></tr></table>\n";
}

sub showInputForm {
    local($data,$subject,$name,$value);
    local(@value,@cookies);
    
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }

    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";    
    print "<table border=0 cellpadding=2 cellspacing=0>\n";    
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=n value=$FORM{'n'}>\n";
    print "<input type=hidden name=p value=1>\n";
    print "<tr><td align=center colspan=2>\n";
    print "<input name=subject value=\" \" type=text size=60 maxlength=40 style=\"border:1 solid $gBaseText; background:;\" onblur=checkField(this) onfocus=clearField(this)>\n";
    print "</td></tr>\n";
    print "<tr><td align=center colspan=2>\n";
    print "<textarea name=content rows=12 cols=59 style=\"border:1 solid $gBaseText; background:;\" onblur=checkField(this) onfocus=clearField(this)> </textarea>\n";
    print "</td></tr>\n";
    print "<tr><td>\n";
    print "&nbsp;&nbsp;<font size=1 face=Tahoma><input type=checkbox name=autolink value=enable checked> auto link enable <input type=checkbox name=html value=enable> html enable</font>&nbsp;&nbsp;&nbsp;\n";
    print "</td><td align=right>\n";
    print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
    print "&nbsp;<input type=reset value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">&nbsp;&nbsp;\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "</form>\n";
    &HTMLFooter;
}

sub writeData {
    &getNumber;
    &getVariable;

    &makeCryptPassword if($passwd);
    &appendIndexFile;
    &makeNewFile;
    $gNoOfData++;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
    print "<p>   Ǿϴ\n";
    print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}></a>]\n";
    &HTMLFooter;
}

sub getVariable {
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }
    unless($FORM{'subject'} =~ /^\s*$/) {
      $subject = "$FORM{'subject'}";
      if($FORM{'subject'} eq ' ') {
          &error(no_subject);
      }
      else {
        $subject =~ s/</&lt;/g;
        $subject =~ s/>/&gt;/g;
        $subject =~ s/"/&quot;/g;
        $subject =~ s/\|/&#124;/g;
		}
	}
    else {
        &error(no_subject);
    }
    if($FORM{'content'}) {
        $content = "$FORM{'content'}";
        if($FORM{'content'} eq ' ') {
            &error(no_content);
		}

        else {
            if($FORM{'html'} ne "enable") { 
                $content =~ s/</&lt;/g;
                $content =~ s/>/&gt;/g;
                $content =~ s/"/&quot;/g;
                $content =~ s/\|/&#124;/g;
            }
            if ($FORM{'autolink'} eq "enable"){
                $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.gif)/<img src=\"\/\/$2\">/gi;
                $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.jpg)/<img src=\"\/\/$2\">/gi;
                $content =~ s/(http:\/\/)([\w\+\-\/\=\?\.\~]+\.bmp)/<img src=\"\/\/$2\">/gi;
                $content =~ s/(http:\/\/)([\w\~+\-\/\=\?\.\~\:]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
                $content =~ s/(ftp:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
                $content =~ s/(telnet:\/\/)([\w\~+\-\/\=\?\.\~]+)/<a href=\"$1$2\" target=_blank>$1$2<\/a>/gi;
                $content =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/<a href=\"mailto:$1\">$1<\/a>/gi;
		    }
            $content =~ s/\r\n\r\n/<p>/g;
            $content =~ s/\r\n/<br>/g;
            $content =~ s/\|/&#124;/g;
		}
	}
    else {
        &error(no_content);
    }
    &getDate;
}

sub getDate {     
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

    if($sec < 10) {
        $sec = "0$sec";
    }
    if($min < 10) {
        $min = "0$min";
    }
    if($hour < 10) {
        $hour = "0$hour";
    }
    $mon++;
    if($mon < 10) {
        $mon = "0$mon";
    }
    if($mday < 10) {
        $mday = "0$mday";
    }

    $year = $year + 1900;
    $date = "$year-$mon-$mday $hour:$min:$sec";
    $d = "$mon$mday";
}      

sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

sub makeNewFile { 
    open(HANDLE,">$gBaseDIR/messages/$filename.txt");
        print HANDLE "$gCryptPassword|$filename|$name|$email|$date|$subject|$content\n";
    close(HANDLE);
}

sub appendIndexFile {
    local($data);
    local(@set,@datum,@value);
    
    @set = ('0'..'9');
    srand(time);
    $filename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";

    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    &lock;
    if($FORM{'l'}) {    
        open(HANDLE,">$gBaseDIR/$gIdxFile");
        foreach $data (@datum) {
            @value = split(/\|/,$data);
            if($value[1] eq $FORM{'l'}) {
                $thread = $value[0] + 1;
                print HANDLE "$data";
                print HANDLE "$thread|$filename|$subject|$name|$email|$date|0\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    else {
        $thread = 0;
        open(HANDLE,">$gBaseDIR/$gIdxFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "$thread|$filename|$subject|$name|$email|$date|0\n";
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}

sub error {
    local($error) = $_[0];

    &HTMLHeader;
    if ($error eq "no_subject") {
        print "<p> ݵ ؾ մϴ\n";
        print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
    }
    else {
        print "<p> ݵ ؾ մϴ\n";
        print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
    }
    &HTMLFooter;
}

sub followData {

    local($PrevNum,$PrevPage,$CurrNum,$NextNum,$NextPage,$data,$seen);
    local(@datum,@value,@PrevLine,@CurrLine,@NextLine);

    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);
    $PrevNum = $FORM{'n'}-1;
    $PrevPage = int(($PrevNum-1)/$gRecPerPage)+1;
    @PrevLine = split(/\|/,$datum[$PrevNum]);
   
    $CurrNum = $FORM{'n'};
    @CurrLine = split(/\|/,$datum[$CurrNum]); 

    $NextNum = $FORM{'n'}+1;
    $NextPage = int(($NextNum-1)/$gRecPerPage)+1;
    @NextLine = split(/\|/,$datum[$NextNum]);


    $gDataNumber = $FORM{'l'};
    &addHitCounter;

    open(HANDLE,"$gBaseDIR/messages/$gDataNumber.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    $actual_number = ($gNoOfData+1)-$FORM{'n'};

    print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
    $seen = substr($CurrLine[6],0,4);
    print "<tr><td>&nbsp;<font size=1 face=Tahoma>No: $actual_number&nbsp;&nbsp;date: $value[4]&nbsp;&nbsp;read: $seen</font>\n"; 
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
	print "<tr bgcolor=$gTableCell><td height=22 align=left>&nbsp;<img src=$gIconURL/head.gif border=0> $value[5]\n";
	print "<td align=right><font size=1 face=Tahoma><a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&c=update_form&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber>edit</a>&nbsp;&nbsp;<a href=$gCGI_URL?id=$FORM{'id'}&action=users_login&c=delete&p=$FORM{'p'}&n=$CurrNum&l=$gDataNumber>delete</a></font>&nbsp;";
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "</table>\n";
	print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=10>\n";
    print "<tr valign=top><td><div style=line-height:140%>$value[6]</div>";
    print "</table>\n";
	print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
    if($PrevNum >= 1) {
		print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
		print "<tr bgcolor=$gTableCell><td height=22 align=left>\n";
        print "&nbsp;<img src=$gIconURL/head.gif border=0> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$PrevLine[0]&p=$PrevPage&n=$PrevNum&l=$PrevLine[1]>$PrevLine[2]<td align=right>&nbsp;\n";
    }
    if($NextNum <= $gNoOfData) { 
		print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
		print "<tr bgcolor=$gTableCell><td height=22 align=left>\n";
        print "&nbsp;<img src=$gIconURL/head.gif border=0> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=$NextLine[0]&p=$NextPage&n=$NextNum&l=$NextLine[1]>$NextLine[2]</a><td align=right>&nbsp;\n";
    }
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
    print "</table>\n";
}

sub addHitCounter {
    local($data,$temp);
    local(@datum,@value,@t);

    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");   
    foreach $data (@datum) {
        @value = split(/\|/,$data);             
        if ($value[1] eq $gDataNumber) {
            $value[6]++;
	    print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]\n";
        }
        else {
             print HANDLE $data;
        }
    }
    close(HANDLE);
    &unlock;

    open(HANDLE,"<$gBaseDIR/messages/$gDataNumber.txt");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);

    $t[8] = $t[8] + 1;
    open(HANDLE,">$gBaseDIR/messages/$gDataNumber.txt");
            print HANDLE "$t[0]|$t[1]|$t[2]|$t[3]|$t[4]|$t[5]|$t[6]|$t[7]|$t[8]|$t[9]";
    close(HANDLE);
}

sub searchData {
    local($data,$counter);
    local(@datum,@value);    

    &getNumber;
    &HTMLHeader;
    unless($FORM{'word'}) {
        print "<p>˻ Է ʾҽϴ\n";
        print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
    }
    else {
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
		print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";

        open(HANDLE,"$gBaseDIR/$gIdxFile");
            @datum = <HANDLE>;
        close(HANDLE);

        $counter = 0 ;
        for($i=1;$i<=$gNoOfData;$i++ ) {
            @v = split(/\|/,$datum[$i]);            
			open(HANDLE,"$gBaseDIR/messages/$v[1].txt");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/,$data);
            if($FORM{'cp'} eq 'subject') {  
                if($value[5] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
                }
            }
			else { 
				if($value[6] =~ /$FORM{'word'}/i) {
                    &printRecord;
                    $counter++;
                }
            }
        }
        print "<table width=$gTableWidth border=0 cellspacing=0 cellpadding=0>\n";
		print "<tr bgcolor=$gTableCell><td height=22 align=center>\n";
        print "˻ <b>$FORM{'word'}</b>() $counter Խù ˻Ǿϴ</td></tr>";
		print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
        print "</table>\n";

        &showSearchForm;

        print "<br><font size=1 face=Tahoma><a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>- list -</a></font>\n";
    } 
    &HTMLFooter;  
}

sub printRecord {
    local($short_subject,$short_date,$actual_number);

    $actual_number = ($gNoOfData+1)-$i;
    print "<tr bgcolor=$gTableCell align=center onMouseOver=this.style.backgroundColor='$gListHover' onMouseOut=this.style.backgroundColor='$gBackColor'>\n";
    $short_subject = substr($v[2],0,50);
    if ($v[0] == 0) {
        print "<td align=left height=22>&nbsp;<img src=$gIconURL/head.gif border=0> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=0&p=$FORM{'p'}&n=$i&l=$v[1]>$short_subject</a></td>";
    }
    else {
        print "<td align=left height=22>&nbsp;<img src=$gIconURL/head.gif border=0> <a href=$gCGI_URL?id=$FORM{'id'}&action=follow&f=1&p=$FORM{'p'}&n=$i&l=$v[1]>$short_subject</a></td>";
    } 
    $short_date = substr($v[5],0,10);
	if ($gShowDate eq "YES"){
        print "<td height=22 align=right>$short_date&nbsp;</td>";
	}
	print "<tr><td colspan=99 background=$gIconURL/dot_cross.gif width=$gTableWidth><img src=$gIconURL/_cl.gif height=1></td></tr>\n";
}

sub showSearchForm {
    print "<form method=post action=$gCGI_URL>\n";
    print "<table border=0 width=$gTableWidth cellspacing=0 cellpadding=1>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=search>\n";
    print "<input type=hidden name=p value=$gCurPage>\n";
    print "<tr align=center valign=middle><td>\n";
	print "<select name=cp value=search style=\"background:$gBackColor\">\n";
    print "<option value=subject>\n";
    print "<option value=content>\n";
	print "</select>\n";
    print "<input type=text size=15 name=word style=\"height:20px;background:;border:1 $gBaseText solid\">&nbsp;<input type=submit value=\"˻\" style=\"height:20px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
    print "</table>\n";
}

sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "update_form";
    }
 
    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=n value=$FORM{'n'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print " йȣ Էϼ<br>\n";
    print "<input type=password name=passwd size=25 maxlength=8 style=\"background:; border:1 $gBaseText solid\"><br>\n";
    print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n" if($command eq "delete");
    print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n" if($command eq "update_form");
    print "</form>\n";
    &HTMLFooter;       
}

sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
        print "<p> йȣ ġ ʽϴ\n";        
        print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
        &HTMLFooter;
    } 
    
}

sub deleteData {
    local(@datum,@value);
    unless(-e "$gBaseDIR/messages/$FORM{'l'}.txt") {
	    $gDelayTime = 500;
        &HTMLHeader;
        print "<p> Խù ̹ Ǿϴ\n";
        print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}></a>]\n";
        &HTMLFooter;
    }

    open(HANDLE,"$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    if($#datum <= 1) {
        open(HANDLE,">$gBaseDIR/messages/00000000");
            print HANDLE "99999999\n";
        close(HANDLE);
    }

    else {
        if($FORM{'n'} == 1) {
            @value = split(/\|/, $datum[2]);
            open(HANDLE,">$gBaseDIR/messages/00000000");
               print HANDLE "$value[1]\n";
            close(HANDLE);
        }
        else {
            if($FORM{'n'} == $#datum) {
                $link = "99999999";
            }
            else {
                @value = split(/\|/, $datum[$FORM{'n'}+1]);
                $link = $value[1];
            }

            @value = split(/\|/, $datum[$FORM{'n'}-1]);
            open(HANDLE,"<$gBaseDIR/messages/$value[1].txt");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/, $data);
            open(HANDLE,">$gBaseDIR/messages/$value[1].txt");
            print HANDLE "$value[0]|$value[1]|$value[2]|$value[3]|$value[4]|$value[5]|$value[6]|$value[7]|$link\n";
            close(HANDLE);
        }
    }

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} ne $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);
    &unlock;

    unlink("$gBaseDIR/messages/$FORM{'l'}.txt");
    $gNoOfData--;
    &putNumber;

    $gDelayTime = 500;
    &HTMLHeader;
    print "<p>Խù  Ǿϴ\n";
    print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}></a>]\n";
    &HTMLFooter;
}

sub showUpdateForm {
    local($data);
    local(@value);
 
    open(HANDLE,"$gBaseDIR/messages/$FORM{'l'}.txt");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &HTMLHeader;
    print "<form method=post action=$gCGI_URL>\n";    
    print "<table border=0 cellpadding=2 cellspacing=0>\n";    
    print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<tr><td align=center colspan=2>\n";
    print "<input name=subject value=\"$value[5]\" type=text size=60 maxlength=40 style=\"background:; border:1 $gBaseText solid\">\n";
    print "</td></tr>\n";
    print "<tr><td align=center colspan=2>\n";
    $value[6] =~ s/<br>/\n/g;
    $value[6] =~ s/<p>/\n\n/g;
    print "<textarea name=content rows=12 cols=59 style=\"background:; border:1 $gBaseText solid\">$value[6]</textarea>\n";
    print "</td></tr>\n";
    print "<tr><td>\n";
    print "&nbsp;&nbsp;<font size=1 face=Tahoma><input type=checkbox name=autolink value=enable checked> auto link enable <input type=checkbox name=html value=enable> html enable</font>&nbsp;&nbsp;&nbsp;\n";
    print "</td><td align=right>\n";
    print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
    print "&nbsp;<input type=reset value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">&nbsp;&nbsp;\n";
    print "</td></tr>\n";
    print "</table>\n";
    print "</form>\n";
    &HTMLFooter;       
}

sub updateData {
    local($temp);
    local(@datum,@value,@t);
  
    &getVariable;
    open(HANDLE,"<$gBaseDIR/$gIdxFile");
        @datum = <HANDLE>;
    close(HANDLE);

    &lock;
    open(HANDLE,">$gBaseDIR/$gIdxFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
            print HANDLE "$value[0]|$FORM{'l'}|$subject|$name|$email|$date|$value[6]";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    &unlock;

    open(HANDLE,"<$gBaseDIR/messages/$FORM{'l'}.txt");
        $temp = <HANDLE>;
    close(HANDLE);
    @t = split(/\|/, $temp);

    open(HANDLE,">$gBaseDIR/messages/$FORM{'l'}.txt");
        print HANDLE "$t[0]|$FORM{'l'}|$name|$email|$date|$subject|$content|$t[7]|$t[8]|$t[9]";
    close(HANDLE);

    $gDelayTime = 500;
    &HTMLHeader;
    print "<p>Խù  Ǿϴ\n";
    print "<p>[<a href=$gCGI_URL?id=$FORM{'id'}&action=read&p=$FORM{'p'}>Խ</a>]\n";
    &HTMLFooter;
}

sub showAdminLogin {
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<form action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print " йȣ ϼ\n";
        print "<table>\n";
        print "<tr align=center><td height=60 width=400>\n";
        print " йȣ <input type=password name=newpasswd size=20 maxlength=8 style=\"background:; border:1 $gBaseText solid\"><br>\n";
        print "йȣ Է <input type=password name=repasswd size=20 maxlength=8 style=\"background:; border:1 $gBaseText solid\"><br>\n";
        print "</table>\n";
        print "<input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
        print "</form>\n";
    }
    else {
        print "<form method=post action=$gCGI_URL>\n";
        print "<input type=hidden name=id value=$FORM{'id'}>\n"; 
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<br><br> йȣ Էϼ\n";
        print "<br><input type=password name=oldpasswd size=25 maxlength=8 style=\"background:;border:1 $gBaseText solid\"><br>\n";
 		print "<select name=action style=\"background:$gBackColor\">";
        print "<option value=$FORM{'c'}> α";
        print "<option value=input_form selected> ۾";
        print "</select>\n";
        print "<br><br><input type=submit value=ϱ style=\"height:18px;background:;border:1 solid $gBaseText;cursor: hand\">\n";
        print "</form>\n";
    }
    close(HANDLE);
    &HTMLFooter;
}
 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);
    
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	            close(HANDLE);
            }
            else {
                &HTMLHeader;
                print "<p> йȣ Է ʾҽϴ\n";
				print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
            print "<p> йȣ ġ ʽϴ\n";
			print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
            &HTMLFooter;
        } 
    } 

    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
            print "<p> йȣ ġ ʽϴ\n";
			print "<p>[<a href=\"javascript:history.back()\">ڷ</a>]\n";
            &HTMLFooter;
        }
    }
}

sub showConfigForm {
    &HTMLHeader;
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#f3f3f3 bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::  ȣ  ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#f3f3f3 bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<form action=$gCGI_URL>\n";
    print "<input type=hidden name=id value=$FORM{'id'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";
    print "<tr><td>ο йȣ</td><td align=right> <input type=password name=newpasswd size=10 maxlength=8></td></tr>\n";
    print "<tr><td>йȣ Է</td><td align=right> <input type=password name=repasswd size=10 maxlength=8></td></tr>\n";
    if($gMakeBoard eq "Y") {
        $gMakeBoard = "";
    } 
    else {
        $gMakeBoard = "";
    }
	print "<tr><td align=right>cgi ߰:</td><td><font color=#ff0000 size=-1><b>$gMakeBoard</b></td></tr>\n";
	print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td> </td><td align=right><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td> ׸</td><td align=right><input type=text name=BackImage value=\"$gBackImage\" size=40></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> :::    ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0 bgcolor=#f3f3f3>\n";    
    print "<tr><td> </td><td align=right><input type=text name=BoardTitle value=\"$gBoardTitle\" size=40></td></tr>\n";
    print "<tr><td> ׸</td><td align=right><input type=text name=BoardImage value=\"$gBoardImage\" size=40></td></tr>\n";
    print "</table></td></tr></table>\n";
    print "<p><table width=500 border=1 cellspacing=0 cellpadding=4 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#e3e3e3><tr><td><b> ::: ⺻ ȯ  ::: </b></td></tr></table>";
    print "<table width=500 border=1 cellspacing=0 cellpadding=0 bordercolordark=#ffffff bordercolorlight=#c0c0c0 bgcolor=#f3f3f3><tr><td><table width=100% border=0 cellpadding=4 cellspacing=0>\n";    
    print "<tr><td>̺ </td><td align=right><input type=text name=TableCell value=\"$gTableCell\" size=10></td></tr>\n";
	print "<tr><td>⺻ ڻ</td><td align=right><input type=text name=BaseText value=\"$gBaseText\" size=10></td></tr>\n";
	print "<tr><td>⺻ ũ</td><td align=right><input type=text name=TextSize value=\"$gTextSize\" size=10></td></tr>\n";
	print "<tr><td>⺻ ۲</td><td align=right><input type=text name=TextFamily value=\"$gTextFamily\" size=10></td></tr>\n";
	print "<tr><td>ũ </td><td align=right><input type=text name=Link value=\"$gLink\" size=10></td></tr>\n";
    print "<tr><td>湮 ũ</td><td align=right><input type=text name=LinkVisited value=\"$gLinkVisited\" size=10></td></tr>\n";
    print "<tr><td>Ȱȭ ũ</td><td align=right><input type=text name=LinkActive value=\"$gLinkActive\" size=10></td></tr>\n";
    print "<tr><td>ũ hover</td><td align=right><input type=text name=LinkHover value=\"$gLinkHover\" size=10></td></tr>\n";
    print "<tr><td>ListHover</td><td align=right><input type=text name=ListHover value=\"$gListHover\" size=10></td></tr>\n";
	print "<tr><td>Խ </td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=10></td></tr>\n";
	print "<tr><td>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=10></td></tr>\n";
    print "<tr><td> </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=10></td></tr>\n";
    print "<tr><td>˻ </td><td align=right><select name=ShowSearch>";
    if($gShowSearch eq "YES") {
        print "<option value=YES selected>";
        print "<option value=NO>";
    }
    else {
        print "<option value=YES>";
        print "<option value=NO selected>";
    }
	print "</select></td></tr>\n";
    print "<tr><td>¥ </td><td align=right><select name=ShowDate>";
    if($gShowDate eq "YES") {
        print "<option value=YES selected>";
        print "<option value=NO>";
    }
    else {
        print "<option value=YES>";
        print "<option value=NO selected>";
    }
	print "</select></td></tr>\n";
	print "</table></td></tr></table>\n";
    print "<p><input type=submit value=ϱ style=\"height:20px;background:$gBackColor;border:1 solid $gBaseText;cursor: hand\" onMouseOver=\"this.style.backgroundColor='$gListHover'\" onMouseOut=\"this.style.backgroundColor='$gBackColor'\">\n";
    print "</form>\n";
    &HTMLFooter;
}

sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gBackColor = $FORM{'BackColor'};
    $gBackImage = $FORM{'BackImage'} if($FORM{'BackImage'} =~ /^http:\/\// || $FORM{'BackImage'} eq "");
    $gBoardTitle = $FORM{'BoardTitle'};
    $gBoardImage = $FORM{'BoardImage'} if($FORM{'BoardImage'} =~ /^http:\/\// || $FORM{'BoardImage'} eq "");
    $gTableCell = $FORM{'TableCell'};
    $gBaseText = $FORM{'BaseText'};
    $gLink = $FORM{'Link'};
    $gLinkVisited = $FORM{'LinkVisited'};
    $gLinkActive = $FORM{'LinkActive'};
    $gLinkHover = $FORM{'LinkHover'};
    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
	$gListHover = $FORM{'ListHover'};
	$gTextSize = $FORM{'TextSize'};
	$gTextFamily = $FORM{'TextFamily'};
    $gListNumber = $FORM{'ListNumber'};
    $gShowSearch = $FORM{'ShowSearch'};
    $gShowDate = $FORM{'ShowDate'};

    &putEnvVar;
    $gCurPage = $FORM{'p'};
    &readData;
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;

    while(-e $LockFile && time < $EndTime) {}
    open(LOCK,">$LockFile");
    chmod 0666,$LockFile;

    if($gLockFlag eq 'Y') {
        flock(LOCK,2);
    }
    $gLockStat = 'Y';
}    

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";

    if($gLockStat eq 'Y') {
        if($gLockFlag eq 'Y') {
            flock(LOCK,8); 
        }
        close(LOCK);
        if(-e $LockFile) { 
            unlink($LockFile);
        }
        $gLockStat = 'N'; 
    }
}

